--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_msapi.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_msapi.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,84 @@
+/* Name: mausb_msapi.c 
+ * Description: This file contains helper functions for using the msapi. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/slab.h> 
+#include <linux/uio.h> 
+#include "mausb_msapi.h" 
+ 
+int mausb_transfer_packet(struct ms_pkt *pkt, 
+ struct mausb_pkt_transfer *transfer) 
+{ 
+ return transfer->transfer_packet(pkt, transfer->context); 
+} 
+EXPORT_SYMBOL(mausb_transfer_packet); 
+ 
+/** 
+ * Calculates the total length of the data in a ms_pkt. Returns the total 
+ * length of the data in the ms_pkt, or a negative errno. 
+ */ 
+int mausb_ms_pkt_length(struct ms_pkt *pkt) 
+{ 
+ int i; 
+ int total_length = 0; 
+ 
+ for (i = 0; i < pkt->nents; ++i) 
+ total_length += pkt[i].kvec->iov_len; 
+ 
+ pr_debug("%s: total *kvec length: %i\n", __func__, total_length); 
+ 
+ return total_length; 
+} 
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_msapi.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_msapi.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_msapi.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_msapi.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,231 @@
+/* Name: mausb_msapi.h 
+ * Description: This header describes how the media agnostic driver 
+ * interfaces with a media specific driver. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+/********************** Initial MS Registration **********************/ 
+ 
+/* The MS driver must initially register with the MA driver to make the 
+ * inital connection. this is done via a call to mausb_register_ms_driver 
+ * (see mausb_hcd.c for details) 
+ */ 
+ 
+/************************ Packet Send/Recieve ************************/ 
+ 
+/* Packets are transferred between the MS and the MA driver via function 
+ * calls into each other. When the MA driver has a packet to send out, it 
+ * makes a function call into the MS driver with the packet it wishes to 
+ * send. Likewise, the MS driver calls into the MA driver if it needs to 
+ * pass it a packet. 
+ */ 
+ 
+/********************** Transfer Pair Add/Remove *********************/ 
+ 
+/* 
+ * The MA driver establishes a new transfer pair for every independant 
+ * connection (ie: one for every independant endpoint, as well as one 
+ * for every device). To establish a new connection, the MA driver 
+ * calls into the MS driver with an incomplete mausb_transfer_pair. 
+ * this incomplete pair includes only the data needed to call into 
+ * the MA driver. 
+ */ 
+ 
+#ifndef __MAUSB_MSAPI_H 
+#define __MAUSB_MSAPI_H 
+ 
+#include <linux/uio.h> 
+ 
+/** 
+ * Offset in Bytes of location of length field - streaming mediums need to 
+ * know where the length field is in a packet so they can determine where 
+ * packets begin and end in the stream. 
+ */ 
+#define MAUSB_PKT_LENGTH_OFFSET 2 
+ 
+/* the largest number of segments that will ever be in a mausb packet */ 
+#define MAUSB_PKT_MAX_NR_SEGS 3 
+ 
+/* This is a convenience structure for keeping the number of entries in 
+ * the kvec with its pointer. 
+ * 
+ * @kvec: The pointer to the ma_pkt kvec or iovec. 
+ * @nents: The number of entires in the ma_pkt kvec or iovec. 
+ */ 
+struct ms_pkt { 
+ union { 
+ struct kvec kvec[MAUSB_PKT_MAX_NR_SEGS]; 
+ struct iovec iovec[MAUSB_PKT_MAX_NR_SEGS]; 
+ }; 
+ int nents; 
+}; 
+ 
+ 
+/** 
+ * This struct defines a one way connection for passing packets from one 
+ * driver to the other. 
+ * 
+ * @transfer_packet: The function call to use when you want to transmit 
+ * a packet. 
+ * @context: The context to use in the function when calling the 
+ * transfer packet. 
+ */ 
+struct mausb_pkt_transfer { 
+ int (*transfer_packet)(struct ms_pkt *pkt, void *context); 
+ void *context; 
+}; 
+ 
+int mausb_transfer_packet(struct ms_pkt *pkt, 
+ struct mausb_pkt_transfer *transfer); 
+ 
+/** 
+ * This struct defines a pair of connections to and from an independant 
+ * endpoint or device. 
+ * 
+ * @to_ma: The transfer to use when passing a packet to the MA driver 
+ * from the MS driver. 
+ * @to_ms: The transfer to use when passing a packet to the MS driver 
+ * from the MA driver. 
+ * @pkt_sent: Packet completion routine. Called by the MS driver into 
+ * the MA driver after the packet has been put onto the medium. 
+ * @handle: A unique identifier for this particualar transfer pair. 
+ * In our implementation, we use the EP/Device Handle. 
+ * For the management channel, set handle to MAUSB_MGMT_HANDLE. 
+ */ 
+ 
+#define MAUSB_MGMT_HANDLE 0 
+ 
+struct mausb_transfer_pair { 
+ struct mausb_pkt_transfer to_ma; 
+ struct mausb_pkt_transfer to_ms; 
+ void (*pkt_sent)(struct ms_pkt *pkt); 
+ unsigned int handle; 
+}; 
+ 
+struct urb; 
+ 
+/** 
+ * This struct defines all the calls the MA USB-HCD Driver can make 
+ * to a media specific driver. 
+ * 
+ * @add_transfer_pair: Used to establish a new transfer pair. 
+ * @tx_pair [IN/OUT]: An incomplete transfer pair. The MA driver 
+ * completes the to_ma field and passes it to 
+ * the MA driver. The MS driver fills the 
+ * to_ma field and returns the pointer. 
+ * @drop_transfer_pair: Used to remove an existing transfer pair. 
+ * @handle [IN]: The unique identifier of the transfer pair 
+ * to remove. 
+ * @pkt_destructor: Used to destroy a packet that was received from 
+ * the medium. Acts as a hook to allow the medium to 
+ * free any media specific data for a packet. 
+ * @pkt [IN] The packet the MA driver wishes to free. 
+ */ 
+struct mausb_ms_ops { 
+ int (*add_transfer_pair)(struct mausb_transfer_pair *tx_pair); 
+ int (*drop_transfer_pair)(unsigned long handle, void *context); 
+ void (*pkt_destructor)(struct ms_pkt *pkt); 
+}; 
+ 
+/** 
+ * This struct defines all of the media-specific parameters needed by 
+ * the MA driver. 
+ * 
+ * TODO: add spec-defined and implementation-specific variables 
+ */ 
+struct mausb_ms_params { 
+ 
+ 
+}; 
+ 
+/** 
+ * This structure includes all of the data needed by the MA driver to 
+ * communicate with the Media Specific Driver. 
+ * 
+ * @ops: Contains function pointers to all of the functions the 
+ * MA driver will ever need to call. 
+ * @params: Contains all of the media-specific paramaters that the 
+ * MA driver needs. 
+ */ 
+struct mausb_ms_drv { 
+ struct mausb_ms_ops *ops; 
+ struct mausb_ms_params *params; 
+}; 
+ 
+/** 
+ * This structure includes all of the ways the Media Specific Driver 
+ * is capable of calling to the Media Agnostic Driver. 
+ * 
+ * @device_connect: Called to indicate that a device has been connected 
+ * and is ready to receive MA packets. 
+ * @pkt_dmux: Used for passing packets into the driver. It will 
+ * parse the packet to determine what endpoint/device 
+ * it belongs to. Used when the medium cannot keep 
+ * data channels seperate. 
+ * @pkt_sent: Used as a notification that a packet has been sent 
+ * out. 
+ */ 
+struct mausb_ma_drv { 
+ int (*device_connect)(int); 
+ struct mausb_pkt_transfer pkt_dmux; 
+ /* TODO: implement pkt_sent indicator */ 
+ /* void (*pkt_sent)(struct ms_pkt *pkt); */ 
+}; 
+ 
+/* function declarations */ 
+struct mausb_ma_drv *mausb_register_ms_driver(struct mausb_ms_drv *drv); 
+struct mausb_ma_drv *maudc_register_ms_driver(struct mausb_ms_drv *drv); 
+int mausb_ms_pkt_length(struct ms_pkt *pkt); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_pkt.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_pkt.c
